#ifndef _CLI_RESULT_FILE_STATEMENT_H_
#define _CLI_RESULT_FILE_STATEMENT_H_

#include <ast/Statement.h>

#include <registry/OutputFileRegistry.hpp>

namespace cli {

class ResultFileStatement final : public Statement {
	std::unique_ptr < cli::Arg > m_file;
	std::unique_ptr < Arg > m_fileType;

public:
	ResultFileStatement ( std::unique_ptr < cli::Arg > file, std::unique_ptr < Arg > fileType ) : m_file ( std::move ( file ) ), m_fileType ( std::move ( fileType ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override {
		return abstraction::OutputFileRegistry::getAbstraction ( prev, m_file->eval ( environment ), "xml" );
	}

	virtual bool getImplicitMove ( ) const override {
		return false;
	}

};

} /* namespace cli */

#endif /* _CLI_RESULT_FILE_STATEMENT_H_ */
