#include "OutputFileTypeRegistration.hpp"

#include <exception/CommonException.h>

#include <registry/XmlRegistry.h>
#include <abstraction/ImmediateValueAbstraction.hpp>
#include <abstraction/XmlTokensComposerAbstraction.hpp>

namespace {

	std::shared_ptr < abstraction::OperationAbstraction > dummy ( std::shared_ptr < abstraction::OperationAbstraction > param, const std::string & filename ) {
		std::shared_ptr < abstraction::OperationAbstraction > tokens = abstraction::XmlRegistry::getXmlComposerAbstraction ( param->getReturnType ( ) );
		if ( ! tokens->attachInput ( param, 0, false ) )
			throw exception::CommonException ( "Can't connect param at 0 of result file statement with result of type " + param->getReturnType ( ) + "." );
		if ( ! tokens->eval ( ) )
			throw exception::CommonException ( "Eval of result file statement failed." );

		std::shared_ptr < abstraction::ImmediateValueAbstraction < std::string > > file = std::make_shared < abstraction::ImmediateValueAbstraction < std::string > > ( filename );

		std::shared_ptr < abstraction::OperationAbstraction > res = std::make_shared < abstraction::XmlTokensComposerAbstraction > ( );

		res->attachInput ( file, 1, false );
		res->attachInput ( tokens, 0, true );
		res->eval ( );

		return res;
	}

auto xmlOutputFileHandler = registration::OutputFileRegister ( "xml", dummy );

}
