/*
 * OutputFileRegistry.cpp
 *
 *  Created on: 28. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <registry/OutputFileRegistry.hpp>
#include <abstraction/XmlComposerAbstraction.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > OutputFileRegistry::getAbstraction ( std::shared_ptr < abstraction::OperationAbstraction > param, const std::string & file, const std::string & fileType ) {
	auto res = getEntries ( ).find ( fileType );
	if ( res == getEntries ( ).end ( ) )
		throw exception::CommonException ( "Entry " + fileType + " not available." );

	return res->second->getAbstraction ( param, file );
}

std::shared_ptr < abstraction::OperationAbstraction > OutputFileRegistry::EntryImpl::getAbstraction ( std::shared_ptr < abstraction::OperationAbstraction > param, const std::string & file ) const {
	return m_callback ( param, file );
}

} /* namespace abstraction */
